#include "Common.h"

#define PLANE "JS_JC_FA18E"
#define DECK 17.5
#define HANGAR 8
#define CLASS "Plane"

private ["_cmd", "_plane", "_loc", "_pos", "_dir", 
         "_endCat", "_nr", "_getCatNr", "_obj"];

_cmd = [_this, 0, "SPAWN"] call BIS_fnc_param;

_loc = TTT_CMDDIALOGCARRIER getVariable "_loc";
_dir = getDir TTT_CMDDIALOGCARRIER;

hint format ["Command received: %1 %2 %3", _cmd, TTT_SELECTEDPOS, _loc];

_spawnPlane = {
  private ["_type", "_pos", "_dir", "_h", "_plane"];
  _type = _this select 0;
  _pos = _this select 1;
  _dir = _this select 2;
  _h = _this select 3;
  _plane = _type createVehicle [100,100,100];
  _plane enableSimulation false;
  _plane setPosASL _pos;
  _plane setDir _dir;
  _plane enableSimulation true;
  [_plane, _h] spawn TTT_fnc_syncSimple;
  // [_plane, ObjNull] call TTT_fnc_syncCatapult; 
  // [_plane, ObjNull] call TTT_fnc_syncIflols; 
  // [_plane, ObjNull] call TTT_fnc_syncTailhook; 
  _plane setFuel 0.5;
  _plane;
};

_getCatNr = {
  private ["_cat", "_nr"];
  _cat = _this;
  switch (TTT_SELECTEDPOS) do {
    case "Catapult 1": { _nr = 1; };
    case "Catapult 2": { _nr = 2; };
    case "Catapult 3": { _nr = 3; };
    case "Catapult 4": { _nr = 4; };
    default { format ["No such cat: %1", TTT_SELECTEDPOS] call BIS_fnc_log;
              _nr = 1; };
  };
  _nr;
};

if (_cmd == "SPAWN") then {
  if (TTT_SELECTEDPOS in 
      ["Catapult 1", "Catapult 2", "Catapult 3", "Catapult 4"]) then {
    _pos = [TTT_SELECTEDPOS, _loc] call TeTeT_fnc_findLoc;
    _plane = [PLANE, _pos, _dir, DECK] call _spawnPlane;
    _nr = TTT_SELECTEDPOS call _getCatNr;
    _endcat = format ["C%1T", _nr];
    [_plane, _endCat] call TTT_fnc_setObjDir;
  } else {
    _height = DECK;
    if (TTT_SELECTEDPOS in ["Hangar 1", "Hangar 2", "Hangar 3"]) then {
      _height = HANGAR;
    }; 
    _pos = [TTT_SELECTEDPOS, _loc] call TeTeT_fnc_findLoc;
    if (TTT_SELECTEDPOS in 
       ["Parking elevator 1", "Parking elevator 2", "Parking elevator 3"]) then {
      _pos = CIRCLEPOS2(_pos, _dir + 90, 2);
      _pos set [2, DECK];
      _plane = [PLANE, _pos, _dir - 90, _height] call _spawnPlane;
    };
    if (TTT_SELECTEDPOS == "Parking elevator 4") then {
      _pos = CIRCLEPOS2(_pos, _dir - 90, 2);
      _pos set [2, DECK];
      _plane = [PLANE, _pos, _dir + 90, _height] call _spawnPlane;
    };
  };
};

if (_cmd == "DESPAWN") then {
  _pos = [TTT_SELECTEDPOS, _loc] call TeTeT_fnc_findLoc;
  _obj = _pos nearestObject CLASS;
  if (!isNull _obj && _pos distance _obj < 10) then {
    format ["Found object %1", _obj] call TeTeT_fnc_tellPlayer;
    deleteVehicle _obj;
  } else {
    "No plane found" call TeTeT_fnc_tellPlayer;
  };
};

if (_cmd == "TAXI") then {
  _pos = [TTT_SELECTEDPOS, _loc] call TeTeT_fnc_findLoc;
  _plane = _pos nearestObject CLASS;
  if (!isNull _plane && _pos distance _plane < 10) then {
    TTT_SELECTEDPLANE = _plane;
    createDialog "TTT_TAXI";
  } else {
    "No plane at taxi position" call TeTeT_fnc_tellPlayer;
  };
};

if (_cmd == "TAKEOFF") then {
  if (TTT_SELECTEDPOS in 
      ["Catapult 1", "Catapult 2", "Catapult 3", "Catapult 4"]) then {
    _pos = [TTT_SELECTEDPOS, _loc] call TeTeT_fnc_findLoc;
    _plane = _pos nearestObject CLASS;
    if (!isNull _plane && _pos distance _plane < 10) then {
      _nr = TTT_SELECTEDPOS call _getCatNr;
      [TTT_CMDDIALOGCARRIER, _plane, _nr, -1] call TeTeT_fnc_planeStart;
    } else {
      "No plane at catapult" call TeTeT_fnc_tellPlayer;
    };
  } else {
    "Need to select a catapult" call TeTeT_fnc_tellPlayer;
  };
};

true;
